aboutsummaryrefslogtreecommitdiff
path: root/bin/u2d.sh
diff options
context:
space:
mode:
Diffstat (limited to 'bin/u2d.sh')
-rw-r--r--bin/u2d.sh26
1 files changed, 26 insertions, 0 deletions
diff --git a/bin/u2d.sh b/bin/u2d.sh
new file mode 100644
index 00000000..9f4e800a
--- /dev/null
+++ b/bin/u2d.sh
@@ -0,0 +1,26 @@
+# Convert UNIX line endings to DOS ones
+
+# Check arguments
+if [ "$#" -eq 0 ] ; then
+ printf >&2 'u2d: Need a filename\n'
+ exit 2
+fi
+
+# Put a carriage return into a variable for convenience
+r=$(printf '\r')
+
+# Iterate over arguments and apply the same ed(1) script to each of them
+for fn ; do
+
+ # Note the heredoc WORD is intentionally unquoted because we want to expand
+ # $r within it to get a literal carriage return; the escape characters
+ # prescribed for ed(1) by POSIX are very limited
+ ed -s -- "$fn" <<EOF || ex=1
+g/[^$r]\$/ s/\$/$r/
+g/^\$/ s/\$/$r/
+w
+EOF
+done
+
+# If any of the ed(1) commands failed, we should exit with 1
+exit "${ex:-0}"